---
title: list-products-for-integration-configuration
product: vercel
url: /docs/rest-api/integrations/list-products-for-integration-configuration
type: reference
prerequisites:
  []
related:
  - /docs/rest-api
summary: Learn about list-products-for-integration-configuration on Vercel.
install_vercel_plugin: npx plugins add vercel/vercel-plugin
---

# List products for integration configuration

```http
GET /v1/integrations/configuration/{id}/products
```

Returns products available for an integration configuration. Each product includes a `metadataSchema` field with the JSON Schema for required and optional metadata fields.

## Authentication

**bearerToken**: HTTP bearer

## Path parameters

| Name | Type | Required | Description |
|---|---|---|---|
| `id` | string | Yes | ID of the integration configuration |


## Query parameters

| Name | Type | Required | Description |
|---|---|---|---|
| `teamId` | string | No | The Team identifier to perform the request on behalf of. |
| `slug` | string | No | The Team slug to perform the request on behalf of. |


## Responses

### 200: List of products available for this integration configuration

Content-Type: `application/json`

```json
{
  "type": "object",
  "required": [
    "configuration",
    "integration",
    "products"
  ],
  "properties": {
    "products": {
      "type": "array",
      "items": {
        "type": "object",
        "required": [
          "id",
          "metadataSchema",
          "name",
          "protocols",
          "slug"
        ],
        "properties": {
          "id": {
            "type": "string"
          },
          "slug": {
            "type": "string"
          },
          "name": {
            "type": "string"
          },
          "protocols": {
            "type": "object",
            "properties": {
              "storage": {
                "type": "object",
                "required": [
                  "status"
                ],
                "properties": {
                  "status": {
                    "type": "string",
                    "enum": [
                      "disabled",
                      "enabled"
                    ]
                  },
                  "repl": {
                    "type": "object",
                    "required": [
                      "enabled",
                      "supportsReadOnlyMode"
                    ],
                    "properties": {
                      "enabled": {
                        "type": "boolean",
                        "enum": [
                          false,
                          true
                        ]
                      },
                      "supportsReadOnlyMode": {
                        "type": "boolean",
                        "enum": [
                          false,
                          true
                        ]
                      },
                      "welcomeMessage": {
                        "type": "string"
                      }
                    }
                  }
                }
              },
              "experimentation": {
                "type": "object",
                "required": [
                  "status"
                ],
                "properties": {
                  "status": {
                    "type": "string",
                    "enum": [
                      "disabled",
                      "enabled"
                    ]
                  },
                  "edgeConfigSyncingSupport": {
                    "type": "boolean",
                    "enum": [
                      false,
                      true
                    ]
                  }
                }
              },
              "ai": {
                "type": "object",
                "required": [
                  "status"
                ],
                "properties": {
                  "status": {
                    "type": "string",
                    "enum": [
                      "disabled",
                      "enabled"
                    ]
                  }
                }
              },
              "authentication": {
                "type": "object",
                "required": [
                  "status"
                ],
                "properties": {
                  "status": {
                    "type": "string",
                    "enum": [
                      "disabled",
                      "enabled"
                    ]
                  }
                }
              },
              "observability": {
                "type": "object",
                "required": [
                  "status"
                ],
                "properties": {
                  "status": {
                    "type": "string",
                    "enum": [
                      "disabled",
                      "enabled"
                    ]
                  }
                }
              },
              "video": {
                "type": "object",
                "required": [
                  "status"
                ],
                "properties": {
                  "status": {
                    "type": "string",
                    "enum": [
                      "disabled",
                      "enabled"
                    ]
                  }
                }
              },
              "workflow": {
                "type": "object",
                "required": [
                  "status"
                ],
                "properties": {
                  "status": {
                    "type": "string",
                    "enum": [
                      "disabled",
                      "enabled"
                    ]
                  }
                }
              },
              "checks": {
                "type": "object",
                "required": [
                  "status"
                ],
                "properties": {
                  "status": {
                    "type": "string",
                    "enum": [
                      "disabled",
                      "enabled"
                    ]
                  }
                }
              },
              "logDrain": {
                "type": "object",
                "required": [
                  "endpoint",
                  "format",
                  "status"
                ],
                "properties": {
                  "status": {
                    "type": "string",
                    "enum": [
                      "disabled",
                      "enabled"
                    ]
                  },
                  "endpoint": {
                    "type": "string"
                  },
                  "headers": {
                    "type": "object",
                    "additionalProperties": {
                      "type": "string"
                    }
                  },
                  "format": {
                    "type": "string",
                    "enum": [
                      "json",
                      "ndjson"
                    ]
                  }
                }
              },
              "traceDrain": {
                "type": "object",
                "required": [
                  "endpoint",
                  "format",
                  "status"
                ],
                "properties": {
                  "status": {
                    "type": "string",
                    "enum": [
                      "disabled",
                      "enabled"
                    ]
                  },
                  "endpoint": {
                    "type": "string"
                  },
                  "headers": {
                    "type": "object",
                    "additionalProperties": {
                      "type": "string"
                    }
                  },
                  "format": {
                    "type": "string",
                    "enum": [
                      "json",
                      "proto"
                    ]
                  }
                }
              },
              "messaging": {
                "type": "object",
                "required": [
                  "status"
                ],
                "properties": {
                  "status": {
                    "type": "string",
                    "enum": [
                      "disabled",
                      "enabled"
                    ]
                  }
                }
              },
              "other": {
                "type": "object",
                "required": [
                  "status"
                ],
                "properties": {
                  "status": {
                    "type": "string",
                    "enum": [
                      "disabled",
                      "enabled"
                    ]
                  }
                }
              }
            }
          },
          "primaryProtocol": {
            "type": "string",
            "enum": [
              "checks",
              "ai",
              "authentication",
              "storage",
              "experimentation",
              "messaging",
              "observability",
              "video",
              "workflow",
              "logDrain",
              "traceDrain",
              "other"
            ]
          },
          "metadataSchema": {
            "type": "object",
            "required": [
              "properties",
              "type"
            ],
            "properties": {
              "type": {
                "type": "string",
                "enum": [
                  "object"
                ]
              },
              "properties": {
                "type": "object",
                "additionalProperties": {
                  "oneOf": [
                    {
                      "type": "object",
                      "required": [
                        "type",
                        "ui:control"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "string"
                          ]
                        },
                        "ui:control": {
                          "type": "string",
                          "enum": [
                            "input"
                          ]
                        },
                        "description": {
                          "type": "string"
                        },
                        "enum": {
                          "type": "array",
                          "items": {
                            "type": "string"
                          }
                        },
                        "maxLength": {
                          "type": "number"
                        },
                        "minLength": {
                          "type": "number"
                        },
                        "pattern": {
                          "type": "string"
                        },
                        "default": {
                          "type": "string"
                        },
                        "ui:label": {
                          "type": "string"
                        },
                        "ui:read-only": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:hidden": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:disabled": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:description": {
                          "oneOf": [
                            {
                              "type": "string"
                            },
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            }
                          ]
                        },
                        "ui:formatted-value": {
                          "type": "object",
                          "required": [
                            "expr"
                          ],
                          "properties": {
                            "expr": {
                              "type": "string"
                            }
                          }
                        },
                        "ui:placeholder": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "type",
                        "ui:control"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "number"
                          ]
                        },
                        "ui:control": {
                          "type": "string",
                          "enum": [
                            "input"
                          ]
                        },
                        "minimum": {
                          "type": "number"
                        },
                        "maximum": {
                          "type": "number"
                        },
                        "description": {
                          "type": "string"
                        },
                        "exclusiveMaximum": {
                          "type": "number"
                        },
                        "exclusiveMinimum": {
                          "type": "number"
                        },
                        "default": {
                          "type": "number"
                        },
                        "ui:label": {
                          "type": "string"
                        },
                        "ui:read-only": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:hidden": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:disabled": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:description": {
                          "oneOf": [
                            {
                              "type": "string"
                            },
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            }
                          ]
                        },
                        "ui:formatted-value": {
                          "type": "object",
                          "required": [
                            "expr"
                          ],
                          "properties": {
                            "expr": {
                              "type": "string"
                            }
                          }
                        },
                        "ui:placeholder": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "type",
                        "ui:control"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "boolean"
                          ]
                        },
                        "ui:control": {
                          "type": "string",
                          "enum": [
                            "toggle"
                          ]
                        },
                        "description": {
                          "type": "string"
                        },
                        "default": {
                          "type": "boolean",
                          "enum": [
                            false,
                            true
                          ]
                        },
                        "ui:label": {
                          "type": "string"
                        },
                        "ui:read-only": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:hidden": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:disabled": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:description": {
                          "oneOf": [
                            {
                              "type": "string"
                            },
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            }
                          ]
                        },
                        "ui:formatted-value": {
                          "type": "object",
                          "required": [
                            "expr"
                          ],
                          "properties": {
                            "expr": {
                              "type": "string"
                            }
                          }
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "items",
                        "type",
                        "ui:control",
                        "ui:steps"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "array"
                          ]
                        },
                        "items": {
                          "type": "object",
                          "required": [
                            "type"
                          ],
                          "properties": {
                            "type": {
                              "type": "string",
                              "enum": [
                                "number"
                              ]
                            },
                            "description": {
                              "type": "string"
                            },
                            "minimum": {
                              "type": "number"
                            },
                            "exclusiveMinimum": {
                              "type": "number"
                            },
                            "maximum": {
                              "type": "number"
                            },
                            "exclusiveMaximum": {
                              "type": "number"
                            },
                            "default": {
                              "type": "number"
                            }
                          }
                        },
                        "ui:control": {
                          "type": "string",
                          "enum": [
                            "slider"
                          ]
                        },
                        "ui:steps": {
                          "type": "array",
                          "items": {
                            "type": "number"
                          }
                        },
                        "description": {
                          "type": "string"
                        },
                        "maxItems": {
                          "type": "number"
                        },
                        "minItems": {
                          "type": "number"
                        },
                        "ui:label": {
                          "type": "string"
                        },
                        "ui:read-only": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:hidden": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:disabled": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:description": {
                          "oneOf": [
                            {
                              "type": "string"
                            },
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            }
                          ]
                        },
                        "ui:formatted-value": {
                          "type": "object",
                          "required": [
                            "expr"
                          ],
                          "properties": {
                            "expr": {
                              "type": "string"
                            }
                          }
                        },
                        "default": {
                          "type": "array",
                          "items": {
                            "type": "number"
                          }
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "type",
                        "ui:control",
                        "ui:options"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "string"
                          ]
                        },
                        "ui:control": {
                          "type": "string",
                          "enum": [
                            "select"
                          ]
                        },
                        "ui:options": {
                          "type": "array",
                          "items": {
                            "type": "object",
                            "required": [
                              "label",
                              "value"
                            ],
                            "properties": {
                              "value": {
                                "type": "string"
                              },
                              "label": {
                                "type": "string"
                              },
                              "description": {
                                "type": "string"
                              },
                              "disabled": {
                                "oneOf": [
                                  {
                                    "type": "object",
                                    "required": [
                                      "expr"
                                    ],
                                    "properties": {
                                      "expr": {
                                        "type": "string"
                                      }
                                    }
                                  },
                                  {
                                    "type": "boolean",
                                    "enum": [
                                      false,
                                      true
                                    ]
                                  },
                                  {
                                    "type": "string",
                                    "enum": [
                                      "update",
                                      "create"
                                    ]
                                  }
                                ]
                              },
                              "hidden": {
                                "oneOf": [
                                  {
                                    "type": "object",
                                    "required": [
                                      "expr"
                                    ],
                                    "properties": {
                                      "expr": {
                                        "type": "string"
                                      }
                                    }
                                  },
                                  {
                                    "type": "boolean",
                                    "enum": [
                                      false,
                                      true
                                    ]
                                  },
                                  {
                                    "type": "string",
                                    "enum": [
                                      "update",
                                      "create"
                                    ]
                                  }
                                ]
                              }
                            }
                          }
                        },
                        "description": {
                          "type": "string"
                        },
                        "enum": {
                          "type": "array",
                          "items": {
                            "type": "string"
                          }
                        },
                        "maxLength": {
                          "type": "number"
                        },
                        "minLength": {
                          "type": "number"
                        },
                        "pattern": {
                          "type": "string"
                        },
                        "default": {
                          "type": "string"
                        },
                        "ui:label": {
                          "type": "string"
                        },
                        "ui:read-only": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:hidden": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:disabled": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:description": {
                          "oneOf": [
                            {
                              "type": "string"
                            },
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            }
                          ]
                        },
                        "ui:formatted-value": {
                          "type": "object",
                          "required": [
                            "expr"
                          ],
                          "properties": {
                            "expr": {
                              "type": "string"
                            }
                          }
                        },
                        "ui:placeholder": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "type",
                        "ui:control",
                        "ui:options"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "string"
                          ]
                        },
                        "ui:control": {
                          "type": "string",
                          "enum": [
                            "radio-button"
                          ]
                        },
                        "ui:options": {
                          "type": "array",
                          "items": {
                            "type": "object",
                            "required": [
                              "label",
                              "value"
                            ],
                            "properties": {
                              "value": {
                                "type": "string"
                              },
                              "label": {
                                "type": "string"
                              },
                              "description": {
                                "type": "string"
                              },
                              "disabled": {
                                "oneOf": [
                                  {
                                    "type": "object",
                                    "required": [
                                      "expr"
                                    ],
                                    "properties": {
                                      "expr": {
                                        "type": "string"
                                      }
                                    }
                                  },
                                  {
                                    "type": "boolean",
                                    "enum": [
                                      false,
                                      true
                                    ]
                                  },
                                  {
                                    "type": "string",
                                    "enum": [
                                      "update",
                                      "create"
                                    ]
                                  }
                                ]
                              },
                              "hidden": {
                                "oneOf": [
                                  {
                                    "type": "object",
                                    "required": [
                                      "expr"
                                    ],
                                    "properties": {
                                      "expr": {
                                        "type": "string"
                                      }
                                    }
                                  },
                                  {
                                    "type": "boolean",
                                    "enum": [
                                      false,
                                      true
                                    ]
                                  },
                                  {
                                    "type": "string",
                                    "enum": [
                                      "update",
                                      "create"
                                    ]
                                  }
                                ]
                              }
                            }
                          }
                        },
                        "description": {
                          "type": "string"
                        },
                        "enum": {
                          "type": "array",
                          "items": {
                            "type": "string"
                          }
                        },
                        "maxLength": {
                          "type": "number"
                        },
                        "minLength": {
                          "type": "number"
                        },
                        "pattern": {
                          "type": "string"
                        },
                        "default": {
                          "type": "string"
                        },
                        "ui:label": {
                          "type": "string"
                        },
                        "ui:read-only": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:hidden": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:disabled": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:description": {
                          "oneOf": [
                            {
                              "type": "string"
                            },
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            }
                          ]
                        },
                        "ui:formatted-value": {
                          "type": "object",
                          "required": [
                            "expr"
                          ],
                          "properties": {
                            "expr": {
                              "type": "string"
                            }
                          }
                        },
                        "ui:placeholder": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "items",
                        "type",
                        "ui:control",
                        "ui:options"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "array"
                          ]
                        },
                        "items": {
                          "type": "object",
                          "required": [
                            "type"
                          ],
                          "properties": {
                            "type": {
                              "type": "string",
                              "enum": [
                                "string"
                              ]
                            },
                            "description": {
                              "type": "string"
                            },
                            "minLength": {
                              "type": "number"
                            },
                            "maxLength": {
                              "type": "number"
                            },
                            "pattern": {
                              "type": "string"
                            },
                            "default": {
                              "type": "string"
                            },
                            "enum": {
                              "type": "array",
                              "items": {
                                "type": "string"
                              }
                            }
                          }
                        },
                        "ui:control": {
                          "type": "string",
                          "enum": [
                            "multi-select"
                          ]
                        },
                        "ui:options": {
                          "type": "array",
                          "items": {
                            "type": "object",
                            "required": [
                              "label",
                              "value"
                            ],
                            "properties": {
                              "value": {
                                "type": "string"
                              },
                              "label": {
                                "type": "string"
                              },
                              "description": {
                                "type": "string"
                              },
                              "disabled": {
                                "oneOf": [
                                  {
                                    "type": "object",
                                    "required": [
                                      "expr"
                                    ],
                                    "properties": {
                                      "expr": {
                                        "type": "string"
                                      }
                                    }
                                  },
                                  {
                                    "type": "boolean",
                                    "enum": [
                                      false,
                                      true
                                    ]
                                  },
                                  {
                                    "type": "string",
                                    "enum": [
                                      "update",
                                      "create"
                                    ]
                                  }
                                ]
                              },
                              "hidden": {
                                "oneOf": [
                                  {
                                    "type": "object",
                                    "required": [
                                      "expr"
                                    ],
                                    "properties": {
                                      "expr": {
                                        "type": "string"
                                      }
                                    }
                                  },
                                  {
                                    "type": "boolean",
                                    "enum": [
                                      false,
                                      true
                                    ]
                                  },
                                  {
                                    "type": "string",
                                    "enum": [
                                      "update",
                                      "create"
                                    ]
                                  }
                                ]
                              }
                            }
                          }
                        },
                        "description": {
                          "type": "string"
                        },
                        "maxItems": {
                          "type": "number"
                        },
                        "minItems": {
                          "type": "number"
                        },
                        "ui:label": {
                          "type": "string"
                        },
                        "ui:read-only": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:hidden": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:disabled": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:description": {
                          "oneOf": [
                            {
                              "type": "string"
                            },
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            }
                          ]
                        },
                        "ui:formatted-value": {
                          "type": "object",
                          "required": [
                            "expr"
                          ],
                          "properties": {
                            "expr": {
                              "type": "string"
                            }
                          }
                        },
                        "ui:placeholder": {
                          "type": "string"
                        },
                        "default": {
                          "type": "array",
                          "items": {
                            "type": "string"
                          }
                        },
                        "example": {
                          "type": "array",
                          "items": {
                            "type": "string"
                          }
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "type",
                        "ui:control",
                        "ui:options"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "string"
                          ]
                        },
                        "ui:control": {
                          "type": "string",
                          "enum": [
                            "vercel-region"
                          ]
                        },
                        "ui:options": {
                          "type": "array",
                          "items": {
                            "oneOf": [
                              {
                                "type": "object",
                                "required": [
                                  "label",
                                  "value"
                                ],
                                "properties": {
                                  "value": {
                                    "type": "string"
                                  },
                                  "label": {
                                    "type": "string"
                                  },
                                  "description": {
                                    "type": "string"
                                  },
                                  "disabled": {
                                    "oneOf": [
                                      {
                                        "type": "object",
                                        "required": [
                                          "expr"
                                        ],
                                        "properties": {
                                          "expr": {
                                            "type": "string"
                                          }
                                        }
                                      },
                                      {
                                        "type": "boolean",
                                        "enum": [
                                          false,
                                          true
                                        ]
                                      },
                                      {
                                        "type": "string",
                                        "enum": [
                                          "update",
                                          "create"
                                        ]
                                      }
                                    ]
                                  },
                                  "hidden": {
                                    "oneOf": [
                                      {
                                        "type": "object",
                                        "required": [
                                          "expr"
                                        ],
                                        "properties": {
                                          "expr": {
                                            "type": "string"
                                          }
                                        }
                                      },
                                      {
                                        "type": "boolean",
                                        "enum": [
                                          false,
                                          true
                                        ]
                                      },
                                      {
                                        "type": "string",
                                        "enum": [
                                          "update",
                                          "create"
                                        ]
                                      }
                                    ]
                                  }
                                }
                              },
                              {
                                "type": "string"
                              },
                              {
                                "type": "object",
                                "required": [
                                  "value"
                                ],
                                "properties": {
                                  "value": {
                                    "type": "string"
                                  },
                                  "description": {
                                    "type": "string"
                                  },
                                  "disabled": {
                                    "oneOf": [
                                      {
                                        "type": "object",
                                        "required": [
                                          "expr"
                                        ],
                                        "properties": {
                                          "expr": {
                                            "type": "string"
                                          }
                                        }
                                      },
                                      {
                                        "type": "boolean",
                                        "enum": [
                                          false,
                                          true
                                        ]
                                      },
                                      {
                                        "type": "string",
                                        "enum": [
                                          "update",
                                          "create"
                                        ]
                                      }
                                    ]
                                  },
                                  "hidden": {
                                    "oneOf": [
                                      {
                                        "type": "object",
                                        "required": [
                                          "expr"
                                        ],
                                        "properties": {
                                          "expr": {
                                            "type": "string"
                                          }
                                        }
                                      },
                                      {
                                        "type": "boolean",
                                        "enum": [
                                          false,
                                          true
                                        ]
                                      },
                                      {
                                        "type": "string",
                                        "enum": [
                                          "update",
                                          "create"
                                        ]
                                      }
                                    ]
                                  }
                                }
                              }
                            ]
                          }
                        },
                        "description": {
                          "type": "string"
                        },
                        "enum": {
                          "type": "array",
                          "items": {
                            "type": "string"
                          }
                        },
                        "maxLength": {
                          "type": "number"
                        },
                        "minLength": {
                          "type": "number"
                        },
                        "pattern": {
                          "type": "string"
                        },
                        "default": {
                          "type": "string"
                        },
                        "ui:label": {
                          "type": "string"
                        },
                        "ui:read-only": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:hidden": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:disabled": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:description": {
                          "oneOf": [
                            {
                              "type": "string"
                            },
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            }
                          ]
                        },
                        "ui:formatted-value": {
                          "type": "object",
                          "required": [
                            "expr"
                          ],
                          "properties": {
                            "expr": {
                              "type": "string"
                            }
                          }
                        },
                        "ui:placeholder": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "items",
                        "type",
                        "ui:control",
                        "ui:options"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "array"
                          ]
                        },
                        "items": {
                          "type": "object",
                          "required": [
                            "type"
                          ],
                          "properties": {
                            "type": {
                              "type": "string",
                              "enum": [
                                "string"
                              ]
                            },
                            "description": {
                              "type": "string"
                            },
                            "minLength": {
                              "type": "number"
                            },
                            "maxLength": {
                              "type": "number"
                            },
                            "pattern": {
                              "type": "string"
                            },
                            "default": {
                              "type": "string"
                            },
                            "enum": {
                              "type": "array",
                              "items": {
                                "type": "string"
                              }
                            }
                          }
                        },
                        "ui:control": {
                          "type": "string",
                          "enum": [
                            "multi-vercel-region"
                          ]
                        },
                        "ui:options": {
                          "type": "array",
                          "items": {
                            "oneOf": [
                              {
                                "type": "object",
                                "required": [
                                  "label",
                                  "value"
                                ],
                                "properties": {
                                  "value": {
                                    "type": "string"
                                  },
                                  "label": {
                                    "type": "string"
                                  },
                                  "description": {
                                    "type": "string"
                                  },
                                  "disabled": {
                                    "oneOf": [
                                      {
                                        "type": "object",
                                        "required": [
                                          "expr"
                                        ],
                                        "properties": {
                                          "expr": {
                                            "type": "string"
                                          }
                                        }
                                      },
                                      {
                                        "type": "boolean",
                                        "enum": [
                                          false,
                                          true
                                        ]
                                      },
                                      {
                                        "type": "string",
                                        "enum": [
                                          "update",
                                          "create"
                                        ]
                                      }
                                    ]
                                  },
                                  "hidden": {
                                    "oneOf": [
                                      {
                                        "type": "object",
                                        "required": [
                                          "expr"
                                        ],
                                        "properties": {
                                          "expr": {
                                            "type": "string"
                                          }
                                        }
                                      },
                                      {
                                        "type": "boolean",
                                        "enum": [
                                          false,
                                          true
                                        ]
                                      },
                                      {
                                        "type": "string",
                                        "enum": [
                                          "update",
                                          "create"
                                        ]
                                      }
                                    ]
                                  }
                                }
                              },
                              {
                                "type": "string"
                              },
                              {
                                "type": "object",
                                "required": [
                                  "value"
                                ],
                                "properties": {
                                  "value": {
                                    "type": "string"
                                  },
                                  "description": {
                                    "type": "string"
                                  },
                                  "disabled": {
                                    "oneOf": [
                                      {
                                        "type": "object",
                                        "required": [
                                          "expr"
                                        ],
                                        "properties": {
                                          "expr": {
                                            "type": "string"
                                          }
                                        }
                                      },
                                      {
                                        "type": "boolean",
                                        "enum": [
                                          false,
                                          true
                                        ]
                                      },
                                      {
                                        "type": "string",
                                        "enum": [
                                          "update",
                                          "create"
                                        ]
                                      }
                                    ]
                                  },
                                  "hidden": {
                                    "oneOf": [
                                      {
                                        "type": "object",
                                        "required": [
                                          "expr"
                                        ],
                                        "properties": {
                                          "expr": {
                                            "type": "string"
                                          }
                                        }
                                      },
                                      {
                                        "type": "boolean",
                                        "enum": [
                                          false,
                                          true
                                        ]
                                      },
                                      {
                                        "type": "string",
                                        "enum": [
                                          "update",
                                          "create"
                                        ]
                                      }
                                    ]
                                  }
                                }
                              }
                            ]
                          }
                        },
                        "description": {
                          "type": "string"
                        },
                        "maxItems": {
                          "type": "number"
                        },
                        "minItems": {
                          "type": "number"
                        },
                        "ui:label": {
                          "type": "string"
                        },
                        "ui:read-only": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:hidden": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:disabled": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:description": {
                          "oneOf": [
                            {
                              "type": "string"
                            },
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            }
                          ]
                        },
                        "ui:formatted-value": {
                          "type": "object",
                          "required": [
                            "expr"
                          ],
                          "properties": {
                            "expr": {
                              "type": "string"
                            }
                          }
                        },
                        "ui:placeholder": {
                          "type": "string"
                        },
                        "default": {
                          "type": "array",
                          "items": {
                            "type": "string"
                          }
                        },
                        "example": {
                          "type": "array",
                          "items": {
                            "type": "string"
                          }
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "type",
                        "ui:control"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "string"
                          ]
                        },
                        "ui:control": {
                          "type": "string",
                          "enum": [
                            "domain"
                          ]
                        },
                        "description": {
                          "type": "string"
                        },
                        "enum": {
                          "type": "array",
                          "items": {
                            "type": "string"
                          }
                        },
                        "maxLength": {
                          "type": "number"
                        },
                        "minLength": {
                          "type": "number"
                        },
                        "pattern": {
                          "type": "string"
                        },
                        "default": {
                          "type": "string"
                        },
                        "ui:label": {
                          "type": "string"
                        },
                        "ui:read-only": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:hidden": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:disabled": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:description": {
                          "oneOf": [
                            {
                              "type": "string"
                            },
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            }
                          ]
                        },
                        "ui:formatted-value": {
                          "type": "object",
                          "required": [
                            "expr"
                          ],
                          "properties": {
                            "expr": {
                              "type": "string"
                            }
                          }
                        },
                        "ui:placeholder": {
                          "type": "string"
                        }
                      }
                    },
                    {
                      "type": "object",
                      "required": [
                        "type",
                        "ui:control"
                      ],
                      "properties": {
                        "type": {
                          "type": "string",
                          "enum": [
                            "string"
                          ]
                        },
                        "ui:control": {
                          "type": "string",
                          "enum": [
                            "git-namespace"
                          ]
                        },
                        "description": {
                          "type": "string"
                        },
                        "ui:label": {
                          "type": "string"
                        },
                        "ui:read-only": {
                          "oneOf": [
                            {
                              "type": "object",
                              "required": [
                                "expr"
                              ],
                              "properties": {
                                "expr": {
                                  "type": "string"
                                }
                              }
                            },
                            {
                              "type": "boolean",
                              "enum": [
                                false,
                                true
                              ]
                            },
                            {
                              "type": "string",
                              "enum": [
                                "update",
                                "create"
                              ]
                            }
                          ]
                        },
                        "ui:hidden": {
                          "oneOf": [
                            {
                              "type": "object",
[...]
